# coding: utf-8

"""
    Mantium API

    Mantium API Documentation  # noqa: E501

    The version of the OpenAPI document: 1.0.438
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from mantium_spec.configuration import Configuration


class ApplicationQueryResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'query': 'str',
        'retriever_top_k': 'int',
        'reader_top_k': 'int',
        'answers': 'list[Answer]',
        'documents': 'list[Document]'
    }

    attribute_map = {
        'query': 'query',
        'retriever_top_k': 'retriever_top_k',
        'reader_top_k': 'reader_top_k',
        'answers': 'answers',
        'documents': 'documents'
    }

    def __init__(self, query=None, retriever_top_k=10, reader_top_k=5, answers=None, documents=None, local_vars_configuration=None):  # noqa: E501
        """ApplicationQueryResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._query = None
        self._retriever_top_k = None
        self._reader_top_k = None
        self._answers = None
        self._documents = None
        self.discriminator = None

        self.query = query
        if retriever_top_k is not None:
            self.retriever_top_k = retriever_top_k
        if reader_top_k is not None:
            self.reader_top_k = reader_top_k
        if answers is not None:
            self.answers = answers
        self.documents = documents

    @property
    def query(self):
        """Gets the query of this ApplicationQueryResponse.  # noqa: E501


        :return: The query of this ApplicationQueryResponse.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this ApplicationQueryResponse.


        :param query: The query of this ApplicationQueryResponse.  # noqa: E501
        :type query: str
        """
        if self.local_vars_configuration.client_side_validation and query is None:  # noqa: E501
            raise ValueError("Invalid value for `query`, must not be `None`")  # noqa: E501

        self._query = query

    @property
    def retriever_top_k(self):
        """Gets the retriever_top_k of this ApplicationQueryResponse.  # noqa: E501


        :return: The retriever_top_k of this ApplicationQueryResponse.  # noqa: E501
        :rtype: int
        """
        return self._retriever_top_k

    @retriever_top_k.setter
    def retriever_top_k(self, retriever_top_k):
        """Sets the retriever_top_k of this ApplicationQueryResponse.


        :param retriever_top_k: The retriever_top_k of this ApplicationQueryResponse.  # noqa: E501
        :type retriever_top_k: int
        """

        self._retriever_top_k = retriever_top_k

    @property
    def reader_top_k(self):
        """Gets the reader_top_k of this ApplicationQueryResponse.  # noqa: E501


        :return: The reader_top_k of this ApplicationQueryResponse.  # noqa: E501
        :rtype: int
        """
        return self._reader_top_k

    @reader_top_k.setter
    def reader_top_k(self, reader_top_k):
        """Sets the reader_top_k of this ApplicationQueryResponse.


        :param reader_top_k: The reader_top_k of this ApplicationQueryResponse.  # noqa: E501
        :type reader_top_k: int
        """

        self._reader_top_k = reader_top_k

    @property
    def answers(self):
        """Gets the answers of this ApplicationQueryResponse.  # noqa: E501


        :return: The answers of this ApplicationQueryResponse.  # noqa: E501
        :rtype: list[Answer]
        """
        return self._answers

    @answers.setter
    def answers(self, answers):
        """Sets the answers of this ApplicationQueryResponse.


        :param answers: The answers of this ApplicationQueryResponse.  # noqa: E501
        :type answers: list[Answer]
        """

        self._answers = answers

    @property
    def documents(self):
        """Gets the documents of this ApplicationQueryResponse.  # noqa: E501


        :return: The documents of this ApplicationQueryResponse.  # noqa: E501
        :rtype: list[Document]
        """
        return self._documents

    @documents.setter
    def documents(self, documents):
        """Sets the documents of this ApplicationQueryResponse.


        :param documents: The documents of this ApplicationQueryResponse.  # noqa: E501
        :type documents: list[Document]
        """
        if self.local_vars_configuration.client_side_validation and documents is None:  # noqa: E501
            raise ValueError("Invalid value for `documents`, must not be `None`")  # noqa: E501

        self._documents = documents

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationQueryResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicationQueryResponse):
            return True

        return self.to_dict() != other.to_dict()
